import numpy as np
import scipy as sp
import os
import matplotlib.pyplot as plt
from scipy.optimize import curve_fit

# Specify the Directory where the data are
#directory = r'C:/Users/pc2009/Dropbox (Heriot-Watt University Team)/RES_EPS_Quantum_Photonics_Lab/Experiments/Current Experiments/SiC_Vanadium/PLE_Scan/D_Lucky_2b/Circular Polarization Excitation/Temperature_3_5K/' #Temperature_3_5K #Temperature_4_3K
#print('aaa')

##################################
# 1 - Load The Data to Analyze ###
##################################
# Specify the Directory where the data are
#Sigma+
directory = r'C:/Users/pc2009/Dropbox (Heriot-Watt University Team)/RES_EPS_Quantum_Photonics_Lab/Experiments/Current Experiments/SiC_Vanadium/PLE_Scan/D_Lucky_2b/Circular Polarization Excitation/Temperature_4_3K/Sigma_Plus_QWP_128_Excitation/'
#Sigma-
directory_2 = r'C:/Users/pc2009/Dropbox (Heriot-Watt University Team)/RES_EPS_Quantum_Photonics_Lab/Experiments/Current Experiments/SiC_Vanadium/PLE_Scan/D_Lucky_2b/Circular Polarization Excitation/Temperature_4_3K/Sigma_Minus_QWP_37_Excitation/'
#Linear
#directory_3 = r'C:/Users/pc2009/Dropbox (Heriot-Watt University Team)/RES_EPS_Quantum_Photonics_Lab/Experiments/Current Experiments/SiC_Vanadium/PLE_Scan/D_Lucky_2b/Circular Polarization Excitation/Temperature_4_3K/Sigma_P_QWP_128_Excit_No_Detection_Polarizers/'

# Specify the file name of the data you want to analyze
Frequency_x = os.path.join(directory, 'D_Lucky_2b_2_2uW_1000Gauss_20s_3_repeats_per_point_QWP_128_HWP_199_4_3K_2022_07_11_18_15_run_1_THz.txt')
Counts_y = os.path.join(directory, 'D_Lucky_2b_2_2uW_1000Gauss_20s_3_repeats_per_point_QWP_128_HWP_199_4_3K_2022_07_11_18_15_run_1_Counts.txt')
#
Frequency_x2 = os.path.join(directory_2, 'D_Lucky_2b_2_2uW_1000Gauss_20s_3_repeats_per_point_HWP_199_4_3K_2022_07_11_13_27_run_1_THz.txt')
Counts_y2 = os.path.join(directory_2, 'D_Lucky_2b_2_2uW_1000Gauss_20s_3_repeats_per_point_HWP_199_4_3K_2022_07_11_13_27_run_1_Counts.txt')
#
# Frequency_x3 = os.path.join(directory_3, 'D_Lucky_2b_4uW_1000Gauss_40s_3_repeats_per_point_QWP_128_NO_HWP_4_3K_from_HtoL_freq_2022_07_18_22_09_run_1_THz.txt')
# Counts_y3 = os.path.join(directory_3, 'D_Lucky_2b_4uW_1000Gauss_40s_3_repeats_per_point_QWP_128_NO_HWP_4_3K_from_HtoL_freq_2022_07_18_22_09_run_1_Counts.txt')

# Load the data
x = np.loadtxt(Frequency_x)
y = np.loadtxt(Counts_y)

x2 = np.loadtxt(Frequency_x2)
y2 = np.loadtxt(Counts_y2)

# x3_values = np.loadtxt(Frequency_x3)
# y3_values = np.loadtxt(Counts_y3)
#

### Order the point in both arrays (due to the mode hoping the points are not in order)
ind = np.argsort(x)
x = x[ind]
y = y[ind]
#
ind_2 = np.argsort(x2)
x2 = x2[ind_2]
y2 = y2[ind_2]

### Convert Everything in cps (i.e., divide by the integration time)
### 0 Gauss ###
# y =y/20         ##   File: D_Lucky_2b_2_2uW_1000Gauss_20s_3_repeats_per_point_QWP_128_HWP_199_4_3K_2022_07_11_18_15_run_1_Counts
# y2 =y2/20       ##   File: D_Lucky_2b_2_2uW_1000Gauss_20s_3_repeats_per_point_HWP_199_4_3K_2022_07_11_13_27_run_1_Counts

### Define Fitting/Plotting Range
x_range_1 = x[(x>234.423) & (x<234.427)]
y_range_1 = y[(x>234.423) & (x<234.427)]

x_range_2 = x2[(x2>234.423) & (x2<234.427)]
y_range_2= y2[(x2>234.423) & (x2<234.427)]

### Error on the counts - Square root of the Counts - divided by 20 to convert in cps
y_err_1 = np.sqrt(y_range_1)/20
y_err_2 = np.sqrt(y_range_2)/20

### Plot Data
plt.errorbar(x_range_1, y_range_1/20, yerr=y_err_1, marker='o', markersize=10, color='crimson', alpha=0.6, linestyle='None', label='$\sigma+$') #, color='b'
plt.errorbar(x_range_2, y_range_2/20, yerr=y_err_2, marker='^', markersize=10, color='royalblue', alpha=0.6, linestyle='None', label='$\sigma-$') #, color='b'


### 1000 Gauss ###
### Sigma+
x_1 = 234.4234
amp_1 = 65 #51 #90 #3*10**8     # counts
y0_1 = 22
cen_1 = 234.4251  # THz
wid_1 = 0.0001   # THz
## Sigma-
x_2 = 234.4234
amp_2 = 55 #3*10**8     # counts
y0_2 = 22 #31 #6*10**7
cen_2 = 234.4246  # THz
wid_2 = 0.0001   # THz
#

def _1Lorentzian(x_1, amp_1, cen_1, wid_1):
    return y0_1 + amp_1 * wid_1 / ((x_1 - cen_1) ** 2 + wid_1 ** 2)

def _1Lorentzian_2(x_2, amp_2, cen_2, wid_2):
    return y0_2 + amp_2 * wid_2 / ((x_2 - cen_2) ** 2 + wid_2 ** 2)

popt_lorentzian, pcov_lorentzian = sp.optimize.curve_fit(_1Lorentzian, x_range_1, y_range_1, p0=[amp_1, cen_1, wid_1])
popt_lorentzian_2, pcov_lorentzian_2 = sp.optimize.curve_fit(_1Lorentzian_2, x_range_2, y_range_2, p0=[amp_2, cen_2, wid_2])
#
#
### Error
perr_lorentz = np.sqrt(np.diag(pcov_lorentzian))
perr_lorentz2 = np.sqrt(np.diag(pcov_lorentzian_2))

pars = popt_lorentzian[0:3]
HWHM = pars[2]*10**6 # pars[2])*10** to go from THz to MHz
FWHM = round(2*HWHM,2) # FWHM = 2xHWHM in MHz
Center = round(pars[1],6)

### Otpimal Parameters rounded to 2 digits precision
amp_opt = popt_lorentzian[0]
cen_opt = popt_lorentzian[1]
wid_opt = popt_lorentzian[2]

amp_opt2 = popt_lorentzian_2[0]
cen_opt2 = popt_lorentzian_2[1]
wid_opt2 = popt_lorentzian_2[2]

### Error of the  Parameters rounded to 2 digits precision
amp_opt_error = perr_lorentz[0]
cen_opt_error = perr_lorentz[1]
wid_opt_error = perr_lorentz[2]

amp_opt_error2 = perr_lorentz2[0]
cen_opt_error2 = perr_lorentz2[1]
wid_opt_error2 = perr_lorentz2[2]

### Extract FWHM and Center
HWHM= round(wid_opt*10**6,2) # *10**6 to go from THZ to MHz
FWHM = round(2*HWHM,2)
FWHM_err = round(2*wid_opt_error,6)
Center = round(cen_opt,6)
Center_err = round(cen_opt_error,6)

HWHM2 = round(wid_opt2*10**6,2)
FWHM2 = round(2*HWHM2,2)
FWHM_err2 = round(2*wid_opt_error2,6)
Center2 = round(cen_opt2,6)
Center_err2 = round(cen_opt_error2,6)

Splitting = round((Center - Center2)*10**6,0) # from THz to MHz
# ####################################################
# ## Print the fitting parameters with their errors ##
# ####################################################
print("-------------Lorentzian Fit-------------")
# print("Amplitude = %0.2f (+/-) %0.2f"' Cps' % (pars[0], perr_lorentz[0]))
# print("Center = %0.6f (+/-) %0.6f" ' THz'% (pars[1], perr_lorentz[1]))
# print("Width = %0.6f (+/-) %0.6f" ' THz'% (pars[2], perr_lorentz[2]))
print("HWHM_P1 = %0.6f " ' THz'% HWHM)
print("FWHM_P1 = %0.6f " ' MHz'% FWHM)
print("Center_P1 = %0.6f " ' THz'% Center)
print("--------------------------------")
print("HWHM_P2 = %0.6f " ' THz'% HWHM2)
print("FWHM_P2 = %0.6f " ' MHz'% FWHM2)
print("Center_P2 = %0.6f " ' THz'% Center2)
print("--------------------------------")
print("Splitting = %0.6f " ' MHz'% Splitting)
#
#
# ###########################
# # Plot the data & Labels ##
# ###########################
plt.plot(x_range_1,_1Lorentzian(x_range_1,*popt_lorentzian),'--',color='crimson') #label='Lorentzian fit' #+str(popt_lorentzian))
plt.plot(x_range_2,_1Lorentzian_2(x_range_2,*popt_lorentzian_2),'--',color='royalblue')

# ## Write Fitting Params on the graph
#plt.plot(x2,_decay(x2,*popt_decay),'--',color='orange', label='Fit. func: $f(x) = %.f * e^{%.3f x} %+.3f$' % (A_opt,-t_opt,b_opt)) #+str(popt_lorentzian))
plt.text(234.42298,60,f"FWHM_1 = {FWHM} $\pm$ {FWHM_err} MHz" + \
                        f"\nCenter_1 = {Center} $\pm$ {Center_err} THz"#+\
                        f"\n" +\
                        f"\nFWHM_2 = {FWHM2} $\pm$ {FWHM_err2} MHz" + \
                        f"\nCenter_2 = {Center2} $\pm$ {Center_err2} THz" #+ \
                        f"\n" + \
                        f"\nSplitting = {Splitting} MHz"
                        ,fontsize=14) ## Text inside the plot

#plt.style.use('classic')
plt.legend(prop={'size': 16})
plt.title('PLE_1000_Gauss')
plt.xlabel('Frequency (THz)', fontsize=16)
plt.ylabel(r'Intensity (Counts/s) ', fontsize=16) #($cps $)
plt.rc('font', family='sans-serif')
plt.rc('font', serif='Helvetica')
#plt.rc('font', serif='Helvetica')
#plt.ylabel(r'Normalized Intensity', fontsize=20) #($cps $)
#plt.ylabel(r'Power (uW) ', fontsize=16) #($cps $)
plt.xticks(fontsize = 16)
plt.yticks(fontsize = 16)
plt.show()

#
#
# #
# # #######################
# # # 2 - Plot the Data ###
# # #######################
# # plt.plot(x_values[2:-2], y_values[2:-2],'o', color='red', label='$\sigma$+ Exc., $\sigma$+ Det.') #y_values*10-9000
# # plt.plot(x2_values[0:-2], y2_values[0:-2],'o', color='blue', label='$\sigma$- Exc., $\sigma$- Det.') #y_values*10-9000
# # #plt.plot(x2_values[0:-2], y2_values[0:-2]*5,'o', color='blue', label='$\sigma$- Exc, P=2.2 uW') #label='V Excit, P=2.2 uW'
# # #plt.plot(x3_values, y3_values,'o', color='green', label='V Exc, P=2.2 uW') #label='V Excit, P=2.2 uW'
#
# #  Add Text - This text starts at x=1 and y=3
# #plt.text(234.426,8000,'Red and Blue Curves x 5', color='red', fontsize= 12)
# plt.legend()
# plt.title('P=2.2 uW, T = 4.3K, B=1000 Gauss,20secx3, From Low to High', fontsize= 10)
# plt.xlabel('Frequency (THz)', fontsize=16)
# plt.ylabel(r'Intensity ($cps$)', fontsize=16)
# plt.show()
#
# # ######################
# # ## 3 - Save the Data ###
# # ######################
# # plt.savefig(fname=directory + 'Comparison Circular Excitation vs Linear Excitation')
# # plt.savefig(fname=directory + time_stamp + '_map_V');
#
#
# ###########################
# ### Fittings ####
# # ###########################
# # # # Specify the file name of the data you want to analyze
# # #Frequency_x = os.path.join(directory, 'D_Lucky_2b_2_2uW_1000Gauss_20s_3_repeats_per_point_QWP_128_HWP_199_4_3K_Reverse_Scan_2022_07_12_11_48_run_1_THz.txt')
# # #Counts_y = os.path.join(directory, 'D_Lucky_2b_2_2uW_1000Gauss_20s_3_repeats_per_point_QWP_128_HWP_199_4_3K_Reverse_Scan_2022_07_12_11_48_run_1_Counts.txt')
# # #
# # #
# # # Load the data
# # x_values = np.loadtxt(Frequency_x2)
# # y_values = np.loadtxt(Counts_y2)
# #
# #
# # #
# # #################################
# # # Perform Operation on the Data #
# # #################################
# # # Average of the 1D Data
# # #average = np.average(y_values)
# # #print(average)
# #
# # ###########################
# # ### Gaussian Fittings ####
# # ###########################
# # #
# # # #Define your parameters - Initial Guess
# # # x = 234.42401
# # # amp1 = 2600      # counts
# # # y0 = 1100
# # # cen1 = 234.425    # THz
# # # sigma1 = 0.001    # THz
# # #
# # # #Define the function
# # # def _1gaussian(x, amp1,cen1,sigma1):
# # #     #return y0 + amp1*(1/(sigma1*(np.sqrt(2*np.pi))))*(np.exp((-1.0/2.0)*(((x_values-cen1)/sigma1)**2)))
# # #     return y0 + amp1*np.exp(-(x_values-cen1)**2/(2*sigma1**2))
# # #
# # # #We then feed this function into a scipy function, along with our x- and y-axis data,
# # # # and our guesses for the function fitting parameters:
# # # popt_gauss, pcov_gauss = sp.optimize.curve_fit(_1gaussian, x_values, y_values, p0=[amp1, cen1, sigma1])
# # #
# # # # Error
# # # perr_gauss = np.sqrt(np.diag(pcov_gauss))
# # #
# # # pars_gauss = popt_gauss[0:3]
# # # FWHM_gauss = 2*np.sqrt(2*np.log(2))*pars_gauss[2]
# # #
# # # ###################################################
# # # # Print the fitting parameters with their errors ##
# # # ###################################################
# # # print("-------------Gaussian Fit-------------")
# # # # print("Amplitude = %0.2f (+/-) %0.2f"' Cps' % (pars_gauss[0], perr_gauss[0]))
# # # # print("Center = %0.6f (+/-) %0.6f" ' THz'% (pars_gauss[1], perr_gauss[1]))
# # # # print("Width = %0.6f (+/-) %0.6f" ' THz'% (pars_gauss[2], perr_gauss[2]))
# # # print("FWHM = %0.6f " ' THz'% FWHM_gauss)
# # # # #print "area = %0.2f" % np.trapz(lorentz_peak_1)
# # # # print("--------------------------------")
# #
# # ##################
# # ## Lorentzian ####
# # ##################
# #
# # Define your parameters - Initial Guess
# x = 234.42401
# amp = 1000     # counts
# y0 = 500
# cen = 234.4251  # THz
# wid = 0.0001   # THz
#
# # Define your parameters - Initial Guess
# x_2 = 234.42401
# amp_2 = 1000     # counts
# y0_2 = 500
# cen_2 = 234.4246  # THz
# wid_2 = 0.0001   # THz
#
# def _1Lorentzian(x, amp, cen, wid):
#     return y0 + amp * wid / ((x - cen) ** 2 + wid ** 2)
#
# def _1Lorentzian_2(x_2, amp_2, cen_2, wid_2):
#     return y0_2 + amp_2 * wid_2 / ((x_2 - cen_2) ** 2 + wid_2 ** 2)
#
# popt_lorentzian, pcov_lorentzian = sp.optimize.curve_fit(_1Lorentzian, x_values, y_values, p0=[amp, cen, wid])
# popt_lorentzian_2, pcov_lorentzian_2 = sp.optimize.curve_fit(_1Lorentzian_2, x2_values, y2_values, p0=[amp_2, cen_2, wid_2])
#
# #
# # Error
# #perr_lorentz = np.sqrt(np.diag(pcov_lorentzian))
# #perr_lorentz = np.sqrt(pcov_lorentzian)
#
# pars = popt_lorentzian[0:3]
# FWHM = 2*(pars[2])#*10**6 # FWHM = 2xHWHM in MHz
#
# pars_2 = popt_lorentzian_2[0:3]
# FWHM_2 = 2*(pars_2[2])#*10**6 # FWHM = 2xHWHM in MHz
#
# ####################################################
# ## Print the fitting parameters with their errors ##
# ####################################################
# print("-------------Lorentzian Fit-------------")
# # print("Amplitude = %0.2f (+/-) %0.2f"' Cps' % (pars[0], perr_lorentz[0]))
# # print("Center = %0.6f (+/-) %0.6f" ' THz'% (pars[1], perr_lorentz[1]))
# # print("Width = %0.6f (+/-) %0.6f" ' THz'% (pars[2], perr_lorentz[2]))
# print("HWHM_$\sigma$+ = %0.6f " ' THz'% pars[2])
# print("FWHM_$\sigma$+ = %0.6f " ' THz'% FWHM)
# #
# print("HWHM_$\sigma$-  = %0.6f " ' THz'% pars_2[2])
# print("FWHM_$\sigma$-  = %0.6f " ' THz'% FWHM_2)
# # #print "area = %0.2f" % np.trapz(lorentz_peak_1)
# # print("--------------------------------")
#
# ############################
# ## Plot the data & Labels ##
# ############################
# #plt.plot(x_values[0:-2], y_values[0:-2],'o', color='blue', label='Data - Sigma_M_QWP_37')
# #plt.plot(x_values, y_values,'o', color='blue', label='Data - S-_QWP_37')
# #plt.plot(x_values,_1gaussian(x_values,*popt_gauss),'o',color='orange', label='Gaussian fit')
# #x_values[-25:-4]
# plt.plot(x_values[2:-2],_1Lorentzian(x_values[2:-2],*popt_lorentzian),'.',color='orange', label='Lorentzian fit') #+str(popt_lorentzian))
# plt.plot(x2_values[0:-2],_1Lorentzian_2(x2_values[0:-2],*popt_lorentzian_2),'.',color='orange', label='Lorentzian fit') #+str(popt_lorentzian))
#
# plt.legend()
# plt.title(" Lor Center: $\sigma$+ = %0.6f" ' THz,'% (pars[1]) + "$\sigma$- = %0.6f" ' THz'% (pars_2[1]) + \
#             #"\nLor Center $\sigma$- = %0.6f" ' THz'% (pars_2[1]) + \
#             #"\n Lor HWHM = %0.6f " 'THz' % pars[2] + \
#             "\n Lor FWHM: $\sigma$+ = %0.6f " 'THz,' % FWHM + "$\sigma$- = %0.6f " 'THz' % FWHM_2, fontsize= 8) #"\t"
#             #"\n Lor FWHM $\sigma$- = %0.6f " 'THz' % FWHM_2, fontsize= 8)
# # plt.title(" Lor Center = %0.6f +/- %0.6f" ' THz'% (pars[1], perr_lorentz[1]) + \
# #           "\n Lor Width = %0.6f +/- %0.6f" ' THz'% (pars[2], perr_lorentz[2]) + \
# #           #"\n Gauss Center = %0.6f (+/-) %0.6f" ' THz'% (pars_gauss[1], perr_gauss[1]) +\
# #           "\n Gauss Width = %0.6f (+/-) %0.6f" ' THz'% (pars_gauss[2], perr_gauss[2]), fontsize= 8)
# plt.xlabel('Frequency (THz)', fontsize=16)
# plt.ylabel(r'Intensity (CPS) ', fontsize=16) #($cps $)
# plt.show()
# #plt.plot(popt_gauss, pcov_gauss,'--')
#
# # ## Save the Data
# #plt.savefig(fname=directory + 'Fitting_D_Lucky_2b_0_05uW_Bg_Subtracted')
# #
#
